<!-- This is the XSL file used by dynwebstats (http://www.monperrus.net/martin/dynwebstats)

chartsvg.xsl
$Revision: 1.10 $
Main ChartSVG xslt file. This is what you must call with your xslt processor

Created by: Virgil Dupras
Created on: 2004/09/11

Last modified by:$Author: freedo $
Last modified on:$Date: 2005/02/28 21:39:21 $

Copyright (C) 2004 Virgil Dupras (http://www.hardcoded.net)

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/2000/svg" exclude-result-prefixes="#default">

<!--<xsl:import href="lib_axis.xsl"/>
<xsl:import href="lib_bar.xsl"/>
<xsl:import href="lib_line.xsl"/>
-->

<!--<xsl:script implements-prefix="math"
      language="java"
      src="java:java.lang.Math" />-->

<xsl:output
	method="xml"
	doctype-public="-//W3C//DTD SVG 1.0//EN"
	doctype-system="http://www.w3.org/TR/SVG/DTD/svg10.dtd"
	indent="yes"
	cdata-section-elements="style"/>

<xsl:template match="xaxis">
	<g id="x_axis">
		<line class="histframe" x1="50" x2="550" y1="350" y2="350">
		</line>
		<text class="axistitle" x="300" y="395">
			<xsl:value-of select="title"/>
		</text>
		<xsl:apply-templates/>
	</g>
</xsl:template>

<xsl:template match="yaxis">
	<text class="axistitle" writing-mode="tb" glyph-orientation-vertical="0" x="10" y="200">
		<xsl:value-of select="title"/>
	</text>
	<g id="y_axis">
		<line class="histframe" x1="50" x2="50" y1="50" y2="350"/>
		<xsl:apply-templates/>
	</g>
</xsl:template>

<!-- NAMED TEMPLATES -->

<xsl:template name="draw_x_grid">
	<xsl:for-each select="line">
		<xsl:variable name="lineno" select="position() - 1"/>
		<xsl:variable name="xpos">
			<xsl:choose>
				<xsl:when test="@x"><xsl:value-of select="50 + @x * (430 div ../../max) "/></xsl:when>
				<xsl:otherwise><xsl:value-of select="$lineno * (430 div count(../line)) "/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<line class="gridline" x1="{$xpos}" x2="{$xpos}" y1="300" y2="310"/>
		<text class="xgrid" x="{$xpos}" y="320">
			<xsl:if test="((../longstrfit) and ((position() mod 2) = 0)) or (@lowered)">
				<xsl:attribute name="y">330</xsl:attribute>
			</xsl:if>
			<xsl:value-of select="."/><!-- label -->
		</text>
	</xsl:for-each>
</xsl:template>

<xsl:template name="draw_y_grid">
	    <xsl:variable name="gridcount" select="count(line)"/>
	    <xsl:variable name="mywidth" select="300 div $gridcount"/>
	    <xsl:variable name="indicator_width" select="500"/>
	    <xsl:variable name="ymax" select="../max"/>
	    <xsl:variable name="ymin" select="sum(../min)"/> <!-- A hack to make the script work even if there is no min element -->
	    <xsl:variable name="ydelta" select="$ymax - $ymin"/>
	    <xsl:for-each select="line">
			<xsl:variable name="lineno" select="position()"/>
			<xsl:variable name="ypos">
				<xsl:choose>
					<xsl:when test="@value"><xsl:value-of select="350 - (((@value - $ymin) div $ydelta) * 300)"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="300 - ($lineno * $mywidth)"/></xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<line class="gridline" x1="40" x2="50" y1="{$ypos}" y2="{$ypos}"/>
			<text class="ygrid" x="39" y="{($ypos+4)}"><xsl:value-of select="."/></text>
			<xsl:if test="@indicator">
				<line class="gridline" style="stroke:{@indicator}" x1="50" x2="{50 + $indicator_width}" y1="{$ypos}" y2="{$ypos}"/>
			</xsl:if>
		</xsl:for-each>
</xsl:template>

<xsl:template name="draw_bar"> <!-- This is called when the man script processes a 'serie' -->
	<g style="stroke:black;stroke-width:1;fill:{color}">
		<xsl:variable name="serieno" select="count(preceding-sibling::*)"/>
		<xsl:variable name="xmax" select="/hsgraph/xaxis/max"/>
		<xsl:variable name="ymax" select="/hsgraph/yaxis/max"/>
	    <xsl:variable name="ymin" select="sum(/hsgraph/yaxis/min)"/> <!-- A hack to make the script work even if there is no min element -->
	    <xsl:variable name="ydelta" select="$ymax - $ymin"/>
		<xsl:variable name="ywidth" select="300 div $ydelta"/>
		<xsl:variable name="scount" select="count(../*)"/>
		<xsl:variable name="xwidth" select="(430) div $xmax"/>
		<xsl:variable name="barwitdh" select="$xwidth  div ($scount+1)"/>

		<xsl:for-each select="point">

			<xsl:variable name="xpos" select="50 + (@x * $xwidth)  - ($xwidth div 4)+ ($barwitdh * $serieno)"/>
			<xsl:variable name="myheight" select="(@y - $ymin) * $ywidth  -10"/>
			<xsl:variable name="ypos" select="300 - $myheight"/>
			<rect y="{$ypos}" x="{$xpos}" height="{$myheight}" width="{$barwitdh}"/>
		</xsl:for-each>
		<xsl:if test="../@showvalues">
			<xsl:for-each select="point">
				<xsl:variable name="xpos" select="50 + (@x * $xwidth)  - ($xwidth div 4) + ($barwitdh * $serieno)"/>

				<xsl:variable name="myheight" select="(@y - $ymin) * $ywidth"/>
				<xsl:variable name="ypos" select="300 - $myheight"/>
				<text class="values" x="{$xpos }" y="{$ypos - 1}">
					<xsl:if test="../@valuecolor">
						<xsl:attribute name="style">
							<xsl:text>fill:</xsl:text><xsl:value-of select="../@valuecolor"/><xsl:text>;</xsl:text>
						</xsl:attribute>
					</xsl:if>
					<xsl:value-of select="@y"/>
				</text>
			</xsl:for-each>
		</xsl:if>
	</g>
</xsl:template>


<xsl:template match="xaxis/grid">
	<xsl:call-template name="draw_x_grid">
	</xsl:call-template>
</xsl:template>

<xsl:template match="yaxis/grid">
	<xsl:call-template name="draw_y_grid"/>
</xsl:template>

<xsl:template match="series/serie">
	<xsl:if test="/hsgraph/charttype = 'line'">
		<xsl:call-template name="draw_line"/>
	</xsl:if>
	<xsl:if test="/hsgraph/charttype = 'bar'">
		<xsl:call-template name="draw_bar"/>
	</xsl:if>
</xsl:template>

<xsl:template match="series">
	<xsl:if test="(/hsgraph/charttype = 'line') or (/hsgraph/charttype = 'bar')">
		<xsl:apply-templates/>
	</xsl:if>
</xsl:template>

<xsl:template match="hsgraph">
	<svg preserveAspectRatio="xMidYMid meet"  x="50" y="50" viewBox="0 0 500 350">
		<xsl:comment>
 Created by ChartSVG - http://www.hardcoded.net/chartsvg/
		</xsl:comment>
		<defs>
			<style type="text/css">
				.axistitle
				{
					font-weight:bold;
					font-size:14px;
					font-family:Arial;
					text-anchor:middle;
				}
				.xgrid, .ygrid, .legendtext
				{
					font-weight:normal;
					font-size:9px;
					font-family:Arial;
				}
				.xgrid {text-anchor:middle;}
				.ygrid {text-anchor:end;}
				.gridline
				{
					stroke:black;
					stroke-width:1;
				}
				.values
				{
					fill:black;
					stroke:none;
					text-anchor:middle;
					font-size:8px;
					font-weight:bold;
				}
	   		</style>
		</defs>
		<xsl:if test="bgcolor">
			<rect x="0" y="0" height="400">
				<xsl:attribute name="width">
					<xsl:if test="showlegend and not(showlegend/@chartfitpos)">800</xsl:if>
					<xsl:if test="not(showlegend) or showlegend/@chartfitpos">600</xsl:if>
				</xsl:attribute>
				<xsl:attribute name="stroke">none</xsl:attribute>
				<xsl:attribute name="fill">
					<xsl:value-of select="bgcolor"/>
				</xsl:attribute>
			</rect>
		</xsl:if>
		<text class="axistitle" x="300" y="20"><xsl:value-of select="title"/></text>
		<xsl:if test="(/hsgraph/charttype = 'line') or (/hsgraph/charttype = 'bar')">
			<xsl:apply-templates/>
			<xsl:apply-templates/>

				<xsl:if test="showlegend and showlegend/@chartfitpos">
					<xsl:call-template name="draw_legend">
						<xsl:with-param name="x_offset">
							<xsl:value-of select="(500 div xaxis/max) * showlegend/@chartfitpos"/>
						</xsl:with-param>
						<xsl:with-param name="y_offset">-15</xsl:with-param>
					</xsl:call-template>
				</xsl:if>
				<xsl:apply-templates/>

		</xsl:if>

		<!--<rect style="fill:none;stroke-width:1;stroke:black;" x="0" y="0" width="600" height="400"/>-->
		<xsl:if test="showlegend and not(showlegend/@chartfitpos)">
				<rect style="fill:none;stroke-width:1;stroke:black;" x="0" y="0" width="200" height="{(count(series/serie) + 2) * 15}"/>
				<xsl:call-template name="draw_legend"/>
		</xsl:if>
	</svg>
</xsl:template>


<!-- NAMED TEMPLATES -->

<xsl:template name="draw_legend">
	<xsl:param name="x_offset" select="0"/>
	<xsl:param name="y_offset" select="0"/>
	<xsl:variable name="total_y" select="sum(*/serie/point/@y)"/>
	<xsl:for-each select="series/serie">
		<xsl:variable name="ypos" select="(position() * 15) + $y_offset"/>
		<rect style="fill:{color};stroke-width:1;stroke:black;" x="{10 + $x_offset}" y="{$ypos}" width="10" height="10"/>
		<text class="legendtext" x="{25 + $x_offset}" y="{$ypos + 10}">
			<xsl:value-of select="name"/>
			<xsl:if test="/hsgraph/showlegend/@showpercent">
				(<xsl:value-of select="round((sum(point/@y) div $total_y) * 100)"/>%)

			</xsl:if>
		</text>
	</xsl:for-each>
</xsl:template>



</xsl:stylesheet>